<?php
/**  ______ _                 _               _ ___
 *  |  ____| |               | |             | |__ \
 *  | |__  | |_   ___      __| |__   ___  ___| |  ) |
 *  |  __| | | | | \ \ /\ / /| '_ \ / _ \/ _ \ | / /
 *  | |    | | |_| |\ V  V / | | | |  __/  __/ |/ /_
 *  |_|    |_|\__, | \_/\_/  |_| |_|\___|\___|_|____|
 *             __/ |
 *            |___/
 *
 * Flywheel2: the inertia php framework
 *
 * @category	Flywheel2
 * @package		constants
 * @author		wakaba <wakabadou@gmail.com>
 * @copyright	2011- Wakabadou honpo (http://www.wakabadou.net/) / Project ICKX (http://www.ickx.jp/)
 * @license		http://opensource.org/licenses/MIT The MIT License MIT
 * @varsion		2.0.0
 */

namespace ickx\fw2\constants\web;

/**
 * カラーコードを管理します。
 *
 * @category	Flywheel2
 * @package		constants
 * @author		wakaba <wakabadou@gmail.com>
 * @license		http://opensource.org/licenses/MIT The MIT License MIT
 * @varsion		2.0.0
 */
class ColorCode {
	//==============================================
	//Color code
	//==============================================
	//----------------------------------------------
	//赤
	//----------------------------------------------
	const INDIAN_RED				= '#CD5C5C';
	const LIGHT_CORAL				= '#F08080';
	const SALMON					= '#FA8072';
	const DARK_SALMON				= '#E9967A';
	const LIGHT_SALMON				= '#FFA07A';
	const CRIMSON					= '#DC143C';
	const RED						= '#FF0000';
	const FIRE_BRICK				= '#B22222';
	const DARK_RED					= '#8B0000';

	//----------------------------------------------
	//ピンク
	//----------------------------------------------
	const PINK						= '#FFC0CB';
	const LIGHT_PINK				= '#FFB6C1';
	const HOT_PINK					= '#FF69B4';
	const DEEP_PINK					= '#FF1493';
	const MEDIUM_VIOLET_RED			= '#C71585';
	const PALE_VIOLET_RED			= '#DB7093';

	//----------------------------------------------
	//橙
	//----------------------------------------------
	const CORAL						= '#FF7F50';
	const TOMATO					= '#FF6347';
	const ORANGE_RED				= '#FF4500';
	const DARK_ORANGE				= '#FF8C00';
	const ORANGE					= '#FFA500';

	//----------------------------------------------
	//黄
	//----------------------------------------------
	const GOLD						= '#FFD700';
	const YELLOW					= '#FFFF00';
	const LIGHT_YELLOW				= '#FFFFE0';
	const LEMON_CHIFFON				= '#FFFACD';
	const LIGHT_GOLDENROD_YELLOW	= '#FAFAD2';
	const PAPAYA_WHIP				= '#FFEFD5';
	const MOCCASIN					= '#FFE4B5';
	const PEACH_PUFF				= '#FFDAB9';
	const PALE_GOLDENROD			= '#EEE8AA';
	const KHAKI						= '#F0E68C';
	const DARK_KHAKI				= '#BDB76B';

	//----------------------------------------------
	//紫
	//----------------------------------------------
	const LAVENDER					= '#E6E6FA';
	const THISTLE					= '#D8BFD8';
	const PLUM						= '#DDA0DD';
	const VIOLET					= '#EE82EE';
	const ORCHID					= '#DA70D6';
	const FUCHSIA					= '#FF00FF';
	const MAGENTA					= '#FF00FF';
	const MEDIUM_ORCHID				= '#BA55D3';
	const MEDIUM_PURPLE				= '#9370DB';
	const AMETHYST					= '#9966CC';
	const BLUE_VIOLET				= '#8A2BE2';
	const DARK_VIOLET				= '#9400D3';
	const DARK_ORCHID				= '#9932CC';
	const DARK_MAGENTA				= '#8B008B';
	const PURPLE					= '#800080';
	const X11_PURPLE				= '#A020F0';
	const INDIGO					= '#4B0082';
	const SLATE_BLUE				= '#6A5ACD';
	const DARK_SLATE_BLUE			= '#483D8B';
	const MEDIUM_SLATE_BLUE			= '#7B68EE';

	//----------------------------------------------
	//緑
	//----------------------------------------------
	const GREEN_YELLOW				= '#ADFF2F';
	const CHARTREUSE				= '#7FFF00';
	const LAWN_GREEN				= '#7CFC00';
	const LIME						= '#00FF00';
	const LIME_GREEN				= '#32CD32';
	const PALE_GREEN				= '#98FB98';
	const LIGHT_GREEN				= '#90EE90';
	const MEDIUM_SPRING_GREEN		= '#00FA9A';
	const SPRING_GREEN				= '#00FF7F';
	const MEDIUM_SEA_GREEN			= '#3CB371';
	const SEA_GREEN					= '#2E8B57';
	const FOREST_GREEN				= '#228B22';
	const GREEN						= '#008000';
	const X11_GREEN					= '#00FF00';
	const DARK_GREEN				= '#006400';
	const YELLOW_GREEN				= '#9ACD32';
	const OLIVE_DRAB				= '#6B8E23';
	const OLIVE						= '#808000';
	const DARK_OLIVE_GREEN			= '#556B2F';
	const MEDIUM_AQUAMARINE			= '#66CDAA';
	const DARK_SEA_GREEN			= '#8FBC8F';
	const LIGHT_SEA_GREEN			= '#20B2AA';
	const DARK_CYAN					= '#008B8B';
	const TEAL						= '#008080';

	//----------------------------------------------
	//青
	//----------------------------------------------
	const AQUA						= '#00FFFF';
	const CYAN						= '#00FFFF';
	const LIGHT_CYAN				= '#E0FFFF';
	const PALE_TURQUOISE			= '#AFEEEE';
	const AQUAMARINE				= '#7FFFD4';
	const TURQUOISE					= '#40E0D0';
	const MEDIUM_TURQUOISE			= '#48D1CC';
	const DARK_TURQUOISE			= '#00CED1';
	const CADET_BLUE				= '#5F9EA0';
	const STEEL_BLUE				= '#4682B4';
	const LIGHT_STEEL_BLUE			= '#B0C4DE';
	const POWDER_BLUE				= '#B0E0E6';
	const LIGHT_BLUE				= '#ADD8E6';
	const SKY_BLUE					= '#87CEEB';
	const LIGHT_SKY_BLUE			= '#87CEFA';
	const DEEP_SKY_BLUE				= '#00BFFF';
	const DODGER_BLUE				= '#1E90FF';
	const CORNFLOWER_BLUE			= '#6495ED';
	const ROYAL_BLUE				= '#4169E1';
	const BLUE						= '#0000FF';
	const MEDIUM_BLUE				= '#0000CD';
	const DARK_BLUE					= '#00008B';
	const NAVY						= '#000080';
	const MIDNIGHT_BLUE				= '#191970';

	//----------------------------------------------
	//茶
	//----------------------------------------------
	const CORNSILK					= '#FFF8DC';
	const BLANCHED_ALMOND			= '#FFEBCD';
	const BISQUE					= '#FFE4C4';
	const NAVAJO_WHITE				= '#FFDEAD';
	const WHEAT						= '#F5DEB3';
	const BURLY_WOOD				= '#DEB887';
	const TAN						= '#D2B48C';
	const ROSY_BROWN				= '#BC8F8F';
	const SANDY_BROWN				= '#F4A460';
	const GOLDENROD					= '#DAA520';
	const DARK_GOLDENROD			= '#B8860B';
	const PERU						= '#CD853F';
	const CHOCOLATE					= '#D2691E';
	const SADDLE_BROWN				= '#8B4513';
	const SIENNA					= '#A0522D';
	const BROWN						= '#A52A2A';
	const MAROON					= '#800000';
	const X11_MAROON				= '#B03060';

	//----------------------------------------------
	//白
	//----------------------------------------------
	const WHITE						= '#FFFFFF';
	const SNOW						= '#FFFAFA';
	const HONEYDEW					= '#F0FFF0';
	const MINT_CREAM				= '#F5FFFA';
	const AZURE						= '#F0FFFF';
	const ALICE_BLUE				= '#F0F8FF';
	const GHOST_WHITE				= '#F8F8FF';
	const WHITE_SMOKE				= '#F5F5F5';
	const SEASHELL					= '#FFF5EE';
	const BEIGE						= '#F5F5DC';
	const OLD_LACE					= '#FDF5E6';
	const FLORAL_WHITE				= '#FFFAF0';
	const IVORY						= '#FFFFF0';
	const ANTIQUE_WHITE				= '#FAEBD7';
	const LINEN						= '#FAF0E6';
	const LAVENDER_BLUSH			= '#FFF0F5';
	const MISTY_ROSE				= '#FFE4E1';

	//----------------------------------------------
	//灰
	//----------------------------------------------
	const GAINSBORO					= '#DCDCDC';
	const LIGHT_GREY				= '#D3D3D3';
	const SILVER					= '#C0C0C0';
	const DARK_GRAY					= '#A9A9A9';
	const GRAY						= '#808080';
	const X11_GRAY					= '#BEBEBE';
	const DIM_GRAY					= '#696969';
	const LIGHT_SLATE_GRAY			= '#778899';
	const SLATE_GRAY				= '#708090';
	const DARK_SLATE_GRAY			= '#2F4F4F';
	const BLACK						= '#000000';

	//==============================================
	//カラー名
	//==============================================
	const NAME_INDIAN_RED				= 'indianred';
	const NAME_LIGHT_CORAL				= 'lightcoral';
	const NAME_SALMON 					= 'salmon';
	const NAME_DARK_SALMON				= 'darksalmon';
	const NAME_LIGHT_SALMON				= 'lightsalmon';
	const NAME_CRIMSON					= 'crimson';
	const NAME_RED						= 'red';
	const NAME_FIRE_BRICK 				= 'firebrick';
	const NAME_DARK_RED					= 'darkred';
	const NAME_PINK						= 'pink';
	const NAME_LIGHT_PINK 				= 'lightpink';
	const NAME_HOT_PINK					= 'hotpink';
	const NAME_DEEP_PINK				= 'deeppink';
	const NAME_MEDIUM_VIOLET_RED		= 'mediumvioletred';
	const NAME_PALE_VIOLET_RED			= 'palevioletred';
	const NAME_CORAL					= 'coral';
	const NAME_TOMATO 					= 'tomato';
	const NAME_ORANGE_RED 				= 'orangered';
	const NAME_DARK_ORANGE				= 'darkorange';
	const NAME_ORANGE 					= 'orange';
	const NAME_GOLD						= 'gold';
	const NAME_YELLOW 					= 'yellow';
	const NAME_LIGHT_YELLOW				= 'lightyellow';
	const NAME_LEMON_CHIFFON			= 'lemonchiffon';
	const NAME_LIGHT_GOLDENROD_YELLOW	= 'lightgoldenrodyellow';
	const NAME_PAPAYA_WHIP				= 'papayawhip';
	const NAME_MOCCASIN					= 'moccasin';
	const NAME_PEACH_PUFF 				= 'peachpuff';
	const NAME_PALE_GOLDENROD 			= 'palegoldenrod';
	const NAME_KHAKI					= 'khaki';
	const NAME_DARK_KHAKI 				= 'darkkhaki';
	const NAME_LAVENDER					= 'lavender';
	const NAME_THISTLE					= 'thistle';
	const NAME_PLUM						= 'plum';
	const NAME_VIOLET 					= 'violet';
	const NAME_ORCHID 					= 'orchid';
	const NAME_FUCHSIA					= 'fuchsia';
	const NAME_MAGENTA					= 'magenta';
	const NAME_MEDIUM_ORCHID			= 'mediumorchid';
	const NAME_MEDIUM_PURPLE			= 'mediumpurple';
	const NAME_AMETHYST					= 'amethyst';
	const NAME_BLUE_VIOLET				= 'blueviolet';
	const NAME_DARK_VIOLET				= 'darkviolet';
	const NAME_DARK_ORCHID				= 'darkorchid';
	const NAME_DARK_MAGENTA				= 'darkmagenta';
	const NAME_PURPLE 					= 'purple';
	const NAME_INDIGO 					= 'indigo';
	const NAME_SLATE_BLUE 				= 'slateblue';
	const NAME_DARK_SLATE_BLUE			= 'darkslateblue';
	const NAME_MEDIUM_SLATE_BLUE		= 'mediumslateblue';
	const NAME_GREEN_YELLOW				= 'greenyellow';
	const NAME_CHARTREUSE 				= 'chartreuse';
	const NAME_LAWN_GREEN 				= 'lawngreen';
	const NAME_LIME						= 'lime';
	const NAME_LIME_GREEN 				= 'limegreen';
	const NAME_PALE_GREEN 				= 'palegreen';
	const NAME_LIGHT_GREEN				= 'lightgreen';
	const NAME_MEDIUM_SPRING_GREEN		= 'mediumspringgreen';
	const NAME_SPRING_GREEN				= 'springgreen';
	const NAME_MEDIUM_SEA_GREEN			= 'mediumseagreen';
	const NAME_SEA_GREEN				= 'seagreen';
	const NAME_FOREST_GREEN				= 'forestgreen';
	const NAME_GREEN					= 'green';
	const NAME_DARK_GREEN 				= 'darkgreen';
	const NAME_YELLOW_GREEN				= 'yellowgreen';
	const NAME_OLIVE_DRAB 				= 'olivedrab';
	const NAME_OLIVE					= 'olive';
	const NAME_DARK_OLIVE_GREEN			= 'darkolivegreen';
	const NAME_MEDIUM_AQUAMARINE		= 'mediumaquamarine';
	const NAME_DARK_SEA_GREEN 			= 'darkseagreen';
	const NAME_LIGHT_SEA_GREEN			= 'lightseagreen';
	const NAME_DARK_CYAN				= 'darkcyan';
	const NAME_TEAL						= 'teal';
	const NAME_AQUA						= 'aqua';
	const NAME_CYAN						= 'cyan';
	const NAME_LIGHT_CYAN 				= 'lightcyan';
	const NAME_PALE_TURQUOISE 			= 'paleturquoise';
	const NAME_AQUAMARINE 				= 'aquamarine';
	const NAME_TURQUOISE				= 'turquoise';
	const NAME_MEDIUM_TURQUOISE			= 'mediumturquoise';
	const NAME_DARK_TURQUOISE 			= 'darkturquoise';
	const NAME_CADET_BLUE 				= 'cadetblue';
	const NAME_STEEL_BLUE 				= 'steelblue';
	const NAME_LIGHT_STEEL_BLUE			= 'lightsteelblue';
	const NAME_POWDER_BLUE				= 'powderblue';
	const NAME_LIGHT_BLUE 				= 'lightblue';
	const NAME_SKY_BLUE					= 'skyblue';
	const NAME_LIGHT_SKY_BLUE 			= 'lightskyblue';
	const NAME_DEEP_SKY_BLUE			= 'deepskyblue';
	const NAME_DODGER_BLUE				= 'dodgerblue';
	const NAME_CORNFLOWER_BLUE			= 'cornflowerblue';
	const NAME_ROYAL_BLUE 				= 'royalblue';
	const NAME_BLUE						= 'blue';
	const NAME_MEDIUM_BLUE				= 'mediumblue';
	const NAME_DARK_BLUE				= 'darkblue';
	const NAME_NAVY						= 'navy';
	const NAME_MIDNIGHT_BLUE			= 'midnightblue';
	const NAME_CORNSILK					= 'cornsilk';
	const NAME_BLANCHED_ALMOND			= 'blanchedalmond';
	const NAME_BISQUE 					= 'bisque';
	const NAME_NAVAJO_WHITE				= 'navajowhite';
	const NAME_WHEAT					= 'wheat';
	const NAME_BURLY_WOOD 				= 'burlywood';
	const NAME_TAN						= 'tan';
	const NAME_ROSY_BROWN 				= 'rosybrown';
	const NAME_SANDY_BROWN				= 'sandybrown';
	const NAME_GOLDENROD				= 'goldenrod';
	const NAME_DARK_GOLDENROD 			= 'darkgoldenrod';
	const NAME_PERU						= 'peru';
	const NAME_CHOCOLATE				= 'chocolate';
	const NAME_SADDLE_BROWN				= 'saddlebrown';
	const NAME_SIENNA 					= 'sienna';
	const NAME_BROWN					= 'brown';
	const NAME_MAROON 					= 'maroon';
	const NAME_WHITE					= 'white';
	const NAME_SNOW						= 'snow';
	const NAME_HONEYDEW					= 'honeydew';
	const NAME_MINT_CREAM 				= 'mintcream';
	const NAME_AZURE					= 'azure';
	const NAME_ALICE_BLUE 				= 'aliceblue';
	const NAME_GHOST_WHITE				= 'ghostwhite';
	const NAME_WHITE_SMOKE				= 'whitesmoke';
	const NAME_SEASHELL					= 'seashell';
	const NAME_BEIGE					= 'beige';
	const NAME_OLD_LACE					= 'oldlace';
	const NAME_FLORAL_WHITE				= 'floralwhite';
	const NAME_IVORY					= 'ivory';
	const NAME_ANTIQUE_WHITE			= 'antiquewhite';
	const NAME_LINEN					= 'linen';
	const NAME_LAVENDER_BLUSH 			= 'lavenderblush';
	const NAME_MISTY_ROSE 				= 'mistyrose';
	const NAME_GAINSBORO				= 'gainsboro';
	const NAME_LIGHT_GREY 				= 'lightgrey';
	const NAME_SILVER 					= 'silver';
	const NAME_DARK_GRAY				= 'darkgray';
	const NAME_GRAY						= 'gray';
	const NAME_DIM_GRAY					= 'dimgray';
	const NAME_LIGHT_SLATE_GRAY			= 'lightslategray';
	const NAME_SLATE_GRAY 				= 'slategray';
	const NAME_DARK_SLATE_GRAY			= 'darkslategray';
	const NAME_BLACK					= 'black';

	//==============================================
	//OSシステムカラー
	//==============================================
	const NAME_ACTIVE_BORDER			= 'ActiveBorder';			//アクティブウィンドウの枠線色
	const NAME_INACTIVE_CAPTION_TEXT	= 'InactiveCaptionText';	//非アクティブウィンドウのタイトルバーの文字色
	const NAME_ACTIVE_CAPTION			= 'ActiveCaption';			//アクティブウィンドウのタイトルバーの色
	const NAME_INFO_BACKGROUND			= 'InfoBackground'; 		//ツールチップの背景色
	const NAME_APP_WORKSPACE			= 'AppWorkspace';			//アプリケーション作業領域の色
	const NAME_INFO_TEXT				= 'InfoText';				//ツールチップの文字色
	const NAME_BACKGROUND				= 'Background'; 			//デスクトップの背景色　※ Safariでも要確認
	const NAME_MENU 					= 'Menu';					//メニューの背景色
	const NAME_BUTTON_FACE				= 'ButtonFace'; 			//ボタンの表面色
	const NAME_MENU_TEXT				= 'MenuText';				//メニューの文字色
	const NAME_BUTTON_HIGHLIGHT 		= 'ButtonHighlight';		//ボタンの明るい面の色
	const NAME_SCROLLBAR				= 'Scrollbar';				//スクロールバーの色
	const NAME_BUTTON_SHADOW			= 'ButtonShadow';			//ボタンの影の色
	const NAME_THREE_D_DARKSHADOW		= 'ThreeDDarkshadow';		//立体的な部分の暗い影の色
	const NAME_BUTTON_TEXT				= 'ButtonText'; 			//ボタンのテキストカラー
	const NAME_THREE_D_SHADOW			= 'ThreeDShadow';			//立体的な部分の影の色
	const NAME_CAPTION_TEXT 			= 'CaptionText';			//タイトルバーの文字色
	const NAME_THREE_D_LIGHT_SHADOW 	= 'ThreeDLightShadow';		//立体的な部分の明るい影の色
	const NAME_GRAY_TEXT				= 'GrayText';				//選択できない無効の部分の色
	const NAME_THREE_D_FACE 			= 'ThreeDFace'; 			//立体的な部分の表面の色
	const NAME_HIGHLIGHT				= 'Highlight';				//選択（反転）部分の色　※ Safariでも要確認
	const NAME_THREE_D_HIGHLIGHT		= 'ThreeDHighlight';		//立体的な部分の明るい色
	const NAME_HIGHLIGHT_TEXT			= 'HighlightText';			//選択部分の文字色　※ 上記 Highlight 参照
	const NAME_WINDOW					= 'Window'; 				//ウィンドウの背景色
	const NAME_INACTIVE_BORDER			= 'InactiveBorder'; 		//非アクティブウィンドウの枠線の色
	const NAME_WINDOW_FRAME 			= 'WindowFrame';			//ウィンドウの枠の色
	const NAME_INACTIVE_CAPTION 		= 'InactiveCaption';		//非アクティブウィンドウのタイトルバーの色
	const NAME_WINDOW_TEXT				= 'WindowText'; 			//ウィンドウの文字色

	//==============================================
	//W3C Standard
	//==============================================
	/**
	 * W3C標準のカラーコードリストを返します。
	 *
	 * @return	array	W3C標準のカラーコードリスト
	 */
	public static function GetW3CStandardColors () {
		return [
			static::BLACK,
			static::GRAY,
			static::SILVER,
			static::WHITE,
			static::BLUE,
			static::NAVY,
			static::TEAL,
			static::GREEN,
			static::LIME,
			static::AQUA,
			static::YELLOW,
			static::RED,
			static::FUCHSIA,
			static::OLIVE,
			static::PURPLE,
			static::MAROON,
		];
	}

	/**
	 * 色名のリストを返します。
	 *
	 * @return	色名のリスト
	 */
	public static function GetColorNameList () {
		return [
			static::NAME_INDIAN_RED,
			static::NAME_LIGHT_CORAL,
			static::NAME_SALMON ,
			static::NAME_DARK_SALMON,
			static::NAME_LIGHT_SALMON,
			static::NAME_CRIMSON,
			static::NAME_RED,
			static::NAME_FIRE_BRICK ,
			static::NAME_DARK_RED,
			static::NAME_PINK,
			static::NAME_LIGHT_PINK ,
			static::NAME_HOT_PINK,
			static::NAME_DEEP_PINK,
			static::NAME_MEDIUM_VIOLET_RED,
			static::NAME_PALE_VIOLET_RED,
			static::NAME_LIGHT_SALMON,
			static::NAME_CORAL,
			static::NAME_TOMATO ,
			static::NAME_ORANGE_RED ,
			static::NAME_DARK_ORANGE,
			static::NAME_ORANGE ,
			static::NAME_GOLD,
			static::NAME_YELLOW ,
			static::NAME_LIGHT_YELLOW,
			static::NAME_LEMON_CHIFFON,
			static::NAME_LIGHT_GOLDENROD_YELLOW,
			static::NAME_PAPAYA_WHIP,
			static::NAME_MOCCASIN,
			static::NAME_PEACH_PUFF ,
			static::NAME_PALE_GOLDENROD ,
			static::NAME_KHAKI,
			static::NAME_DARK_KHAKI ,
			static::NAME_LAVENDER,
			static::NAME_THISTLE,
			static::NAME_PLUM,
			static::NAME_VIOLET ,
			static::NAME_ORCHID ,
			static::NAME_FUCHSIA,
			static::NAME_MAGENTA,
			static::NAME_MEDIUM_ORCHID,
			static::NAME_MEDIUM_PURPLE,
			static::NAME_AMETHYST,
			static::NAME_BLUE_VIOLET,
			static::NAME_DARK_VIOLET,
			static::NAME_DARK_ORCHID,
			static::NAME_DARK_MAGENTA,
			static::NAME_PURPLE ,
			static::NAME_INDIGO ,
			static::NAME_SLATE_BLUE ,
			static::NAME_DARK_SLATE_BLUE,
			static::NAME_MEDIUM_SLATE_BLUE,
			static::NAME_GREEN_YELLOW,
			static::NAME_CHARTREUSE ,
			static::NAME_LAWN_GREEN ,
			static::NAME_LIME,
			static::NAME_LIME_GREEN ,
			static::NAME_PALE_GREEN ,
			static::NAME_LIGHT_GREEN,
			static::NAME_MEDIUM_SPRING_GREEN,
			static::NAME_SPRING_GREEN,
			static::NAME_MEDIUM_SEA_GREEN,
			static::NAME_SEA_GREEN,
			static::NAME_FOREST_GREEN,
			static::NAME_GREEN,
			static::NAME_DARK_GREEN ,
			static::NAME_YELLOW_GREEN,
			static::NAME_OLIVE_DRAB ,
			static::NAME_OLIVE,
			static::NAME_DARK_OLIVE_GREEN,
			static::NAME_MEDIUM_AQUAMARINE,
			static::NAME_DARK_SEA_GREEN ,
			static::NAME_LIGHT_SEA_GREEN,
			static::NAME_DARK_CYAN,
			static::NAME_TEAL,
			static::NAME_AQUA,
			static::NAME_CYAN,
			static::NAME_LIGHT_CYAN ,
			static::NAME_PALE_TURQUOISE ,
			static::NAME_AQUAMARINE ,
			static::NAME_TURQUOISE,
			static::NAME_MEDIUM_TURQUOISE,
			static::NAME_DARK_TURQUOISE ,
			static::NAME_CADET_BLUE ,
			static::NAME_STEEL_BLUE ,
			static::NAME_LIGHT_STEEL_BLUE,
			static::NAME_POWDER_BLUE,
			static::NAME_LIGHT_BLUE ,
			static::NAME_SKY_BLUE,
			static::NAME_LIGHT_SKY_BLUE ,
			static::NAME_DEEP_SKY_BLUE,
			static::NAME_DODGER_BLUE,
			static::NAME_CORNFLOWER_BLUE,
			static::NAME_MEDIUM_SLATE_BLUE,
			static::NAME_ROYAL_BLUE ,
			static::NAME_BLUE,
			static::NAME_MEDIUM_BLUE,
			static::NAME_DARK_BLUE,
			static::NAME_NAVY,
			static::NAME_MIDNIGHT_BLUE,
			static::NAME_CORNSILK,
			static::NAME_BLANCHED_ALMOND,
			static::NAME_BISQUE ,
			static::NAME_NAVAJO_WHITE,
			static::NAME_WHEAT,
			static::NAME_BURLY_WOOD ,
			static::NAME_TAN,
			static::NAME_ROSY_BROWN ,
			static::NAME_SANDY_BROWN,
			static::NAME_GOLDENROD,
			static::NAME_DARK_GOLDENROD ,
			static::NAME_PERU,
			static::NAME_CHOCOLATE,
			static::NAME_SADDLE_BROWN,
			static::NAME_SIENNA ,
			static::NAME_BROWN,
			static::NAME_MAROON ,
			static::NAME_WHITE,
			static::NAME_SNOW,
			static::NAME_HONEYDEW,
			static::NAME_MINT_CREAM ,
			static::NAME_AZURE,
			static::NAME_ALICE_BLUE ,
			static::NAME_GHOST_WHITE,
			static::NAME_WHITE_SMOKE,
			static::NAME_SEASHELL,
			static::NAME_BEIGE,
			static::NAME_OLD_LACE,
			static::NAME_FLORAL_WHITE,
			static::NAME_IVORY,
			static::NAME_ANTIQUE_WHITE,
			static::NAME_LINEN,
			static::NAME_LAVENDER_BLUSH ,
			static::NAME_MISTY_ROSE ,
			static::NAME_GAINSBORO,
			static::NAME_LIGHT_GREY ,
			static::NAME_SILVER ,
			static::NAME_DARK_GRAY,
			static::NAME_GRAY,
			static::NAME_DIM_GRAY,
			static::NAME_LIGHT_SLATE_GRAY,
			static::NAME_SLATE_GRAY ,
			static::NAME_DARK_SLATE_GRAY,
			static::NAME_BLACK,
		];
	}

	/**
	 * 与えられた光の3原色、10進数の値が利用可能なカラーコードかどうか判定します。
	 *
	 * @param	int		$red	光の三原色：赤の10進数値
	 * @param	int		$green	光の三原色：緑の10進数値
	 * @param	int		$blue	光の三原色：青の10進数値
	 * @return	bool	与えられた光の3原色の10進数値がカラーコードとして使える場合はbool true、そうでない場合はbool false
	 */
	public static function IsDecColorCode ($red, $green, $blue) {
		return static::IsHexColorCode(static::ToHexString($red, $green, $blue));
	}

	/**
	 * 与えられた光の3原色、16進数の値が利用可能なカラーコードかどうか判定します。
	 *
	 * @param	string	$rgb	光の3原色の16進数値
	 * @return	bool	与えられた光の3原色、16進数の値がカラーコードとして使える場合はbool true、そうでない場合はbool false
	 */
	public static function IsHexColorCode ($rgb) {
		return (($hex_array = static::ToHexStringArray($rgb)) !== false) ? ctype_xdigit($hex_array[0]) && ctype_xdigit($hex_array[1]) && ctype_xdigit($hex_array[2]) : false;
	}

	/**
	 * 16進数表記の光の三原色を10進数、3要素の配列の変換します。
	 *
	 * @param	$rgb	10進数の配列に変換する16進数表記のカラーコード
	 * @return	array	10進数の配列に変換された16進数表記のカラーコード
	 */
	public static function ToDecArray ($rgb) {
		return (($hex_array = static::ToHexStringArray($rgb)) !== false) ? [hexdec($hex_array[0]), hexdec($hex_array[1]), hexdec($hex_array[2])] : false;
	}

	/**
	 * 16進数表記のカラーコードを16進数で色ごとに分割した配列に変換します。
	 *
	 * @param	string	$rgb	16進数表記のカラーコード
	 * @return	array	色ごとに分割された16進数のカラーコード
	 */
	public static function ToHexStringArray ($rgb) {
		$rgb = trim($rgb, '#');
		if ($rgb === '' || ($range = strlen($rgb) / 3) > 2) {
			return false;
		}

		$hex_array = [substr($rgb, 0, $range), substr($rgb, 1 * $range, $range), substr($rgb, 2 * $range, $range)];
		if ($range === 1) {
			$hex_array[0] .= $hex_array[0];
			$hex_array[1] .= $hex_array[1];
			$hex_array[2] .= $hex_array[2];
		}

		return $hex_array;
	}

	/**
	 * 光の三原色、10進数の値をもとにカラーコードを構築します。
	 *
	 * @param	int		$red	赤
	 * @param	int		$green	緑
	 * @param	int		$blue	青
	 * @return	string	16進数表記のカラーコード
	 */
	public static function ToHexString ($red, $green, $blue) {
		$rgb = sprintf('#%02X%02X%02X', $red, $green, $blue);
	}
}
